//------ nécessaire pour gérer le port série ----------
import processing.serial.*;
Serial port=null;
//----------------------------------------------------
//////////////////////////////////////////// setup() /////////////////////////////////////////////////////////////////////////
void setup() {
    size(1364, 743, P2D);
    colorMode(RGB, 255, 255, 255);
    imageMode(CORNER);
    noStroke();
    Repertoire_Decoduino = sketchPath("");
                                                                                                                              println(Repertoire_Decoduino);
    Courier12 = createFont(Repertoire_Decoduino+"data/SLC_.ttf", 12, true);
    Courier14 = createFont(Repertoire_Decoduino+"data/SLC_.ttf", 14, true);
    Courier17 = createFont(Repertoire_Decoduino+"data/SLC_.ttf", 17, true);
    Courier25 = createFont(Repertoire_Decoduino+"data/SLC_.ttf", 25, true);
    fontUnits = createFont(Repertoire_Decoduino+"data/DSEG7Classic-BoldItalic.ttf", TAILLE_POLICE, true);
    textFont(Courier12);
    textFont(Courier14);
    textFont(Courier17);
    textFont(Courier25);
    int Repertoire_Decoduino_length = Repertoire_Decoduino.length();
    Repertoire_Communs = Repertoire_Decoduino.substring(0, Repertoire_Decoduino_length-25)+"Communs/";
    
    filenames = listFileNames(Repertoire_Communs+"Vehicules");
                                                                                                                              println(Repertoire_Communs);
    fond_alu1 = loadImage("data/Fond alu1.png");
    fond_alu  = loadImage("data/Fond alu.png");
    creation_table_Base_decodeurs();
    charge_table_Base_decodeurs();
    gestion   = new Gestion();
    imageMode(CORNER);                                                                                                        //  on affiche le plus tôt possible dans le setup() pour diminuer l'écran blanc du départ
    image(fond_alu, 0, 0, width, height);
    String texte = "Chargement des fichiers";
    gestion.dessine_rectangle_bosse((width-500)/2F, (height-300F)/2F, 500F, 300F);
    textFont(Courier17);
    textAlign(CENTER, CENTER);
    text(texte, width/2F, height/2F);
    zone         = new Zone();
    bouton       = new Bouton();
    trouve       = false;
    texte_ecrire = "";
    compte_demo  = 0;
}
/////////////////////////////////// draw() ///////////////////////////////////////////////////////////
void draw() {
    if (charge_tables) {
        image(fond_alu, 0, 0, width, height);                                                                                 //  on doit réafficher en entrant dans le draw() pour eviter un écran noi
        String texte = "Chargement des fichiers";
        gestion.dessine_rectangle_bosse((width-500)/2F, (height-300F)/2F, 500F, 300F);
        text(texte, width/2F, height/2F);
        gestion.liste_decodeurs();
        gestion.liste_fabricants();
        gestion.liste_familles();
        gestion.liste_modeles();
        
        charge_images();
        
        creation_table_Vehicules();
        charge_table_Vehicules();
        
        creation_table_Infos_CV();
        charge_table_Infos_CV();
        
        creation_table_Proprietaires();
        charge_table_Proprietaires();
        
        creation_table_Base_decodeurs();
        charge_table_Base_decodeurs();
        
        creation_table_Compositions();
        charge_table_Compositions();

        if (tables_construites) {
            charge_tables = false;
        }
    } else {
        if (cherche_fichier) {
            recherche_fichiers_ouverts();
            cherche_fichier = false;
            vehicule = tous_vehicules_complet.get(0);
            sauvegarde_vehicule();
            infos_CV = toutes_infos_CV.get(0);
            sauvegarde_infos_CV();
            initialise_CV_decodeur();
            proprietaire = tous_proprietaires.get(0);
            initialise_prop();
            debut_comptage = millis();
        } else {
            if (cherche_arduino) {
                switch (compte_demo) {
                    case 0 :
                        if (texte_ecrire.equals("")) {
                            connexion();
                        }
                        gestion.dessine_rectangle_bosse((width-500)/2F, (height-300F)/2F-60F, 500F, 50F);
                        textFont(Courier17);
                        textAlign(CENTER, CENTER);
                        text(texte_ecrire, width/2F, height/2F-190F);
                        compte_demo++;
                        break;
                    case 1 :
                        //***************************************************************************
                        if (trouve) {
                            texte_ecrire =        "Vous pouvez choisir le mode DEMO :"
                                        +char(10)+"Vous travaillez uniquement sur les fichiers,"
                                        +char(10)+"MAIS VOUS NE POUVEZ NI LIRE NI ECRIRE"
                                        +char(10)+"DANS LES DECODEURS"
                               +char(10)+char(10)+"Ou vous pouvez choisir le mode COMPLET :"
                                        +char(10)+"Sauvegarde en parallèle dans les fichiers"                            
                                        +char(10)+"et dans les décodeurs";                            
                        } else {
                            texte_ecrire =        "Vous pouvez choisir le mode DEMO :"
                                        +char(10)+"Vous travaillez uniquement sur les fichiers,"
                                        +char(10)+"MAIS VOUS NE POUVEZ NI LIRE NI ECRIRE"
                                        +char(10)+"DANS LES DECODEURS"
                               +char(10)+char(10)+"Ou vous pouvez choisir de SORTIR et :"
                                        +char(10)+"1°) Branchez un Arduino avec son MotorShield"
                                        +char(10)+"2°) Téléversez le sketch DCC_controller.ino"
                                        +char(10)+"    dans l'Arduino"
                                        +char(10)+"3°) Relancez le programme Decoduino";
                        }
                        gestion.dessine_rectangle_bosse((width-500)/2F, (height-300F)/2F, 500F, 300F);
                        textFont(Courier17);
                        textAlign(CENTER, CENTER);
                        text(texte_ecrire, width/2F, height/2F);
                        compte_demo++;
                        break;
                    case 2 :
                        gestion.dessine_rectangle_bosse((width-500)/2F, (height+300F)/2F+10F, 500F, 70F);
                        image(affiche_bleu, width/2F, height/2F+200F, 20F, 20F);
                        textFont(Courier17);
                        textAlign(CENTER, CENTER);
                        if (trouve) {
                            texte_ecrire = "Démo ou Complet ? (d/c)";
                            text(texte_ecrire, width/2F, height/2F+ 180F);
                            //****************************************************************************
                           if (texte_saisi.equals("d") || texte_saisi.equals("D")) {
                                demo = true;
                                cherche_arduino   = false;
                                choix_du_vehicule = true;
                                texte_saisi       = "";
                            } else {
                                if (texte_saisi.equals("c") || texte_saisi.equals("C")) {
                                    demo = false;
                                    cherche_arduino   = false;
                                    choix_du_vehicule = true;
                                    texte_saisi       = "";
                                }
                            }
                        } else {
                            texte_ecrire = "Démo ou Sortie ? (d/s)";
                            text(texte_ecrire, width/2F, height/2F+180F);
                            fill(NOIR);
                            if (texte_saisi.equals("d") || texte_saisi.equals("D")) {
                                demo = true;
                                cherche_arduino   = false;
                                choix_du_vehicule = true;
                                texte_saisi       = "";
                            } else {
                                if (texte_saisi.equals("s") || texte_saisi.equals("S")) {
                                    exit();                                        
                                }
                            }
                        }
                        text(texte_saisi, width/2F+10F, height/2F+210F);
                        break;
                }
            } else {
                if (mousePressed) {
                    top++;
                } else {
                    top = 0;
                }
                //---------------------- choix du véhicule ---------------
                if (choix_du_vehicule) {
                    imageMode(CORNER);
                    image(fond_alu, 0, 0, width, height);
                    gestion.choix_vehicule();
                }
                //---------------------- pupitre ---------------
                if (affiche_pupitre) {
                    imageMode(CORNER);
                    image(pupitre_fond, 0, 0, width, height);
                    gestion.pupitre();
                }
                //---------------------- Bouton ajouter un décodeur -----------------
                if (ajouter_decodeur) {
                    if (gestion.one_shot) {
                        imageMode(CORNER);
                        image(fond_alu, 0, 0, width, height);
                        gestion.dessine_fabricants();
                        gestion.dessine_familles();
                        gestion.dessine_modeles();
                    }                    
                    maj_decodeur = true;
                }
                //---------------------- Bouton MàJ décodeur -----------------
                if (maj_decodeur) {
                    gestion.dessine_decodeur();
                    for (Decodeur dec0 : tous_decodeurs) {
                        decodeur = dec0;
                        if (dec0.onglet_choisi != null) {
                            for (Onglet ong0 : tous_onglets) {
                                if (ong0.nom_onglet.equals(dec0.onglet_choisi)) {
                                    ong0.dessine_onglet();
                                    onglet = ong0;
                                    if (onglet.Groupes[0] != null) {
                                        groupe = onglet.Groupes[0];
                                        int nb_zones = min(NB_CHOIX, groupe.Boutons.length);
                                        for (int i = 0; i < nb_zones; i++) {
                                            bouton = groupe.Boutons[i];
                                            //--------------- cas particulier de l'ajout de décodeur où on met les valeurs usine au départ ------------
                                            if (ajouter_decodeur && groupe.numero_groupe == 5 && i == 29) {
                                                bouton.valeurs_usine();
                                                sauve_table_Infos_CV();
                                                ajouter_decodeur = false;
                                            }
                                            //--------------------- choisir_texte ------------------------
                                            if (groupe.Boutons[i].choix[i]) {
                                                groupe.Boutons[i].liste_choix(i);
                                            }
                                        }
                                    }
                                    int nb_groupes = onglet.Groupes.length;
                                    if (nb_groupes > 1) {
                                        if (onglet.Groupes[1] != null) {
                                            if (onglet.nom_onglet.equals("Tableau des CVs")) {
                                                groupe1.transferts();
                                            } else {
                                                int nb_zones = onglet.Groupes[1].Boutons.length;
                                                for (int i = 0; i < nb_zones; i++) {
                                                     groupe1.valide_onglet();
                                                }
                                            }
                                        }
                                    }
                                }
                            }  
                        }
                    }
                }
                //--------------------- Coller les CV ------------------------
                if (coller_CV) {
                    groupe = groupes[1];
                    groupe.choix_bouton_copie();
                }
                //--------------------- Boutons_confirmation -------------------------
                if (confirmation) {
                    groupe = groupes[3];
                    groupe.confirmation();
                }
                //--------------------- Sauver et sortir ---------------------
                if (sauver_et_sortir) {
                    sauve_table_Vehicules();
                    sauver_et_sortir  = false;
                    choix_du_vehicule = true;
                }
                //-------------------- lire_CV -----------------------------
                if (appui_CV != 0 && !transfert_fich_dec && !transfert_dec_fich) {
                    lire_CV();
                }
            }
        }
    }
}
