//*************************************** Gestion() ********************************************
class Gestion {
    Decodeur decodeurs[] = new Decodeur[NB_DECODEURS];
    Decodeur decodeur_choisi;
    float   largeur_fabricant = 0F;
    String  fabricant_choisi  = ".";
    int     ligne_fabricant   = -1;
    float   largeur_famille   = 0F;
    String  famille_choisie   = ".";
    int     ligne_famille     = -1;
    float   largeur_modele    = 0F;
    String  modele_choisi     = ".";
    int     ligne_modele      = -1;
    boolean one_shot          = false;
    float   x0                = 120F;
    float   y0                = 270F;
    float   l0                = width-240F;
    float   curseur_left      = x0;
    float   curseur_right     = x0+l0;
    int     numero_curseur    = 0;
    float   largeur_curseur[] = new float[2];
    String  texte_echelle;
    int     nixie[]           = new int[5];

    Gestion() {
        for (int i = 0; i < NB_DECODEURS; i++) {
            decodeurs[i] = new Modele_generique(tous_decodeurs_base.get(i).reference,
                                                tous_decodeurs_base.get(i).NMRA,
                                                tous_decodeurs_base.get(i).courant_moteur_max,
                                                tous_decodeurs_base.get(i).courant_pic_moteur,
                                                tous_decodeurs_base.get(i).duree_pic_moteur,
                                                tous_decodeurs_base.get(i).courant_total_max,
                                                tous_decodeurs_base.get(i).courant_pic_total,
                                                tous_decodeurs_base.get(i).connecteur,
                                                tous_decodeurs_base.get(i).longueur,
                                                tous_decodeurs_base.get(i).largeur,
                                                tous_decodeurs_base.get(i).hauteur);
        }       
        groupes[0]  = new Choix_vehicule();
        groupes[1]  = new Copie_ligne2();
        groupes[3]  = new Boutons_confirmation();
        groupes[4]  = new Choix_compo();
        groupes[50] = new Haut_bas0();
        groupes[51] = new Haut_bas2();
        groupes[52] = new Pupitre();
        groupes[53] = new Boutons_vehicule();
        groupes[54] = new Boutons_filtres();
        groupes[55] = new Boutons_decodeur();
        groupes[56] = new Boutons_composition();
    }

    //---------------------------- choix_vehicule() ----------------------
    void choix_vehicule() {
        pupitre = false;
        //------------------------ case de l'image du véhicule ---------------------
        dessine_rectangle_creux(GRIS, x0-60, y0-250, l0+120, y0-50);
        imageMode(CENTER);
        image(vehicule.image_cote, width/2F, y0-145, vehicule.image_cote.width, vehicule.image_cote.height);
        //----------------------- curseurs véhicules --------------------
        stroke(NOIR);
        strokeWeight(3);
        line(x0, y0, x0+l0, y0);
        //----------------------- variables du véhicule ------------------------------
        dessine_rectangle_creux(GRIS, x0-60, y0+30, 650, 190);
        dessine_rectangle_creux(GRIS, 750,   y0+30, 556, 190);
        
        fill(NOIR);
        textFont(Courier14);
        textAlign(CENTER, CENTER);
        text("INFOS SUR LE VEHICULE", x0-60F+650/2F, y0+40);
        text("INFOS SUR LE DECODEUR", 750F+556F/2F,  y0+40);
        textAlign(LEFT, CENTER);
        text("Nom :",                  x0-60F+10,     y0+60F);
        text("Marque :",               x0-60F+10F,    y0+75F);
        text("Référence :",            x0-60F+10F,    y0+90F);
        text("ID du véhicule :",       x0-60F+370F,   y0+60F);
        text("Propiétaire :",          x0-60F+370F,   y0+75F);
        text("Hors tampons (en mm) :", x0-60F+370F,   y0+90F);
        text("Fabricant :",            x0-60F+700F,   y0+60F);
        text("Famille :",              x0-60F+700F,   y0+75F);
        text("Modèle :",               x0-60F+700F,   y0+90F);
        text("Adresse DCC :",          x0-60F+700F,   y0+105F);
        text("Nombre de crans de vitesse :", x0-60F+700F,   y0+120F);
        text("Gestion de vitesse :",         x0-60F+700F,   y0+135F);
        
        fill(AQUA);
        textAlign(RIGHT, CENTER);
        text(vehicule.nom,             x0-60F+300F,   y0+60F);
        text(vehicule.marque,          x0-60F+300F,   y0+75F);
        text(vehicule.ref,             x0-60F+300F,   y0+90F);
        text(str(vehicule.ID),         x0-60F+620F,   y0+60F);
        if (vehicule.CV106 == 0) {
            text("n.c.",               x0-60F+620F,   y0+75F);
        } else {
            for (Proprietaire prop0 : tous_proprietaires) {
                if (vehicule.CV106 == prop0.CV106) {
                    proprietaire = prop0;
                    for (int i = 0; i < 29; i++) {
                        prop[i] = proprietaire.F[i];
                    }
                    text(prop0.prop,   x0-60F+620F,   y0+75F);
                    break;
                }
            }
        }
        text(str(vehicule.htamp),      x0-60F+620F,   y0+90F);
        if (vehicule.ID_CV != 0) {
            text(infos_CV.fabricant,                x0-60F+1220F,  y0+60F);
            text(infos_CV.famille,                  x0-60F+1220F,  y0+75F);
            text(infos_CV.modele,                   x0-60F+1220F,  y0+90F);
            //---------- adresse ----------
            int CV29_bit5 = int(binary(infos_CV.CV[29], 8).substring(7-5, 7-5+1));
            if (CV29_bit5 == 0) {
                text(infos_CV.CV[1], x0-60F+1220F,  y0+105F);
            } else {
                text((infos_CV.CV[17]-192)*256+infos_CV.CV[18], x0-60F+1220F,  y0+105F);
            }
            //---------- nb crans vitesse ----------
            int CV29_bit1 = int(binary(infos_CV.CV[29], 8).substring(7-1, 7-1+1));
            if (CV29_bit1 == 0) {
                text(" 28 crans", x0-60F+1220F,  y0+120F);
            } else {
                text("128 crans", x0-60F+1220F,  y0+120F);
            }
            //---------- gestion de vitesse ----------
            int CV29_bit4 = int(binary(infos_CV.CV[29], 8).substring(7-4, 7-4+1));
            if (CV29_bit4 == 0) {
                text(" Gestion à 3 points", x0-60F+1220F,  y0+135F);
            } else {
                text("Gestion à 28 points", x0-60F+1220F,  y0+135F);
            }
        } else {
            text("Sans decodeur", x0-60F+1220F,  y0+60F);
            text("-",             x0-60F+1220F,  y0+75F);
            text("-",             x0-60F+1220F,  y0+90F);
            text("-",             x0-60F+1220F,  y0+105F);
            text("-",             x0-60F+1220F,  y0+120F);
            text("-",             x0-60F+1220F,  y0+135F);
        }
        text(str(vehicule.rang+1)+"/"+str(tous_vehicules.size()), x0-60F+l0+120-10F,   y0-240F);
        if (copier_CV) {
            fill(AQUA);
            textAlign(CENTER, TOP);
            text("Véhicule dont les CV sont à copier", 60F+((l0+120F)/4F)/2F, 600F);
            //---------------- vehicule ---------------        
            dessine_rectangle_creux(GRIS, 60F, 630F, (l0+120F)/4F, 100F);
            imageMode(CENTER);
            image(tous_vehicules.get(vehicule_copie).image_cote, 60F+((l0+120F)/4F)/2F, 630F+100F/2F, 
                  tous_vehicules.get(vehicule_copie).image_cote.width/4F, tous_vehicules.get(vehicule_copie).image_cote.height/4F);
            imageMode(CORNER);
        }
        if (coller_CV) {            
            fill(AQUA);
            textAlign(CENTER, TOP);
            if (vehicule.ID_CV != 0) {
                text("Véhicule dans lequel on copie les CV", 60F+((l0+120F)/4F)+60F+((l0+120F)/4F)/2F, 600F);
            } else {
                imageMode(CORNER);
                image(danger, 60F+((l0+120F)/4F)+60F, 600F, 20F, 20F);
                textAlign(LEFT, TOP);
                text("On ne peut pas coller les CV dans un véhicule qui n'a pas de décodeur", 60F+300F+60F+30F+10F, 600F);
            }
            //---------------- vehicule ---------------        
            dessine_rectangle_creux(GRIS, 60F+((l0+120F)/4F)+60F, 630F, ((l0+120F)/4F), 100F);
            imageMode(CENTER);
            image(vehicule.image_cote, 60F+((l0+120F)/4F)+60F+((l0+120F)/4F)/2F, 630F+100F/2F, vehicule.image_cote.width/4F, vehicule.image_cote.height/4F);
            imageMode(CORNER);
        }
        if (!copier_CV) {
            //-------------------------------------------------- composition des trains ------------------------------------------------------------------------------------------
            imageMode(CORNER);
            image(composition, 0F, 543F, width, 200F);
            dessine_rectangle_creux(GRIS, 15F, 543F+145F, 935F, 35F);
            fill(AQUA);
            textAlign(CENTER, CENTER);
            text(toutes_compositions.get(choix_train).nom, 15F+935F/2F, 543F+142F+35F/2F);            
            textAlign(LEFT, CENTER);
            fill(AQUA);
            text((choix_train+1)+"/"+toutes_compositions.size(), 80F, 547F);
            compo_train.clear();
            for (int i = 0; i < 20; i++) {
                if (toutes_compositions.get(choix_train).veh[i] != null) {
                    compo_train.add(toutes_compositions.get(choix_train).veh[i]);
                } else {
                    break;
                }
            }
            groupe = groupes[4];
            groupe.choix_vehicule_compo(x0-60F, y0+250F-10F, l0+100F);
            //----------------------- curseurs composition --------------------
            stroke(NOIR);
            strokeWeight(3);
            line(x0, y0+250F, x0+l0, y0+250F);
            dessine_curseurHC(y0+250F);                                                                   //  Curseur composition
            //------------------------------------------- appui sur les petits boutons haut et bas ------------------------------------------
            if (choix_train != -1) {                                                                                                                         //  si on a choisi un train
                for (int d = 0; d < 2; d++) {
                    for (int u = 0; u < 10; u++) {
                        if (compo_train.size() > 10*d+u) {                                                                                                   //  si on a dépassé le nombre de véhicules
                            if (mouseX > 115+u*135             && mouseX < 135+u*135                                                                         //  bouton du haut : véhicule 10*d+u
                             && mouseY > (height-200)+15+d*65  && mouseY < (height-200)+35+d*65) {
                                if (top == 1) { 
                                    Composition compo1 = toutes_compositions.get(choix_train);
                                    for (int i = 19; i > 10*d+u; i--) {
                                        compo1.veh[i] = compo1.veh[i-1];
                                    }
                                    compo1.veh[10*d+u] = vehicule;
                                    toutes_compositions.set(choix_train, compo1);
                                    compo_train.set(10*d+u, vehicule);
                                }
                            }            
                            if (mouseX > 115+u*135             && mouseX < 135+u*135                                                                         //  bouton du bas  : véhicule 10*d+u 
                             && mouseY > (height-200)+45+d*65  && mouseY < (height-200)+65+d*65) {
                                if (top == 1) { 
                                                                                                              println("bouton bas");
                                    Composition compo1 = toutes_compositions.get(choix_train);
                                    for (int i = 10*d+u; i < 19; i++) {
                                        compo1.veh[i] = compo1.veh[i+1];
                                    }
                                    toutes_compositions.set(choix_train, compo1);
                                }
                            }
                        } else {
                            if (mouseX > 115+u*135             && mouseX < 135+u*135                                                                         //  bouton du haut : véhicule 10*d+u
                             && mouseY > (height-200)+15+d*65  && mouseY < (height-200)+35+d*65) {
                                if (top == 1) { 
                                                                                                              println("bouton haut");
                                    Composition compo1 = toutes_compositions.get(choix_train);
                                    compo1.veh[10*d+u] = vehicule;
                                    toutes_compositions.set(choix_train, compo1);
                                    compo_train.add(vehicule);
                                }
                            }            
                            
                        }
                    }
                }
            }        
            //------------------------------------------ affichage d'une composition --------------------------------------
            int memo_d = -1;
            int memo_u = -1;
            for (int d = 0; d < 2; d++) {
                for (int u = 0; u < 10; u++) {
                    if (choix_train == -1) {                                                                                                            //--- si on n'a pas sélectionné de train : FOND_TRAIN
                        fill(FOND_TRAIN);
                        rect(17+u*135, (height-200)+17+d*65, 96, 46);
                    } else {                                                                                                                            //--- si on a sélectionné un train
                        if (10*d+u >= compo_train.size()) {                                                                                             //----- si on a dépassé le nombre de véhicules : FOND_TRAIN
                            fill(FOND_TRAIN);
                            rect(17+u*135, (height-200)+17+d*65, 96, 46);
                        } else {                                                                                                                        //----- si on est dans un véhicule, on peut l'afficher
                            Vehicule veh1 = compo_train.get(10*d+u);                                                                                    //  simplification d'écriture pour le choix du véhicule
                            if (veh1.rang == 0) {                                                                                                       //------- si on est arrivé à un véhicule null : FOND_TRAIN
                                fill(FOND_TRAIN);
                                rect(17+u*135, (height-200)+17+d*65, 96, 46);
                            } else {                                                                                                                    //------- si on est dans un véhicule normal, on l'affiche
                                imageMode(CENTER);
                                fill(veh1.couleur);
                                rect(17+u*135, (height-200)+17+d*65, 96, 46);
                                image(veh1.image_cote, 17+u*135+48, (height-200)+17+d*65+23, min(96, veh1.image_cote.width/10), veh1.image_cote.height*min(96, veh1.image_cote.width/10)/veh1.image_cote.width);
                                imageMode(CORNER);
                                //---------------------- affiche nom du véhicule ------
                                textAlign(CENTER, CENTER);
                                noStroke();
                                fill(AQUA);
                                strokeWeight(2);
                                textSize(12);
                                text(veh1.nom, (u-1F+(max(-1F, -int((width-width)+.5F))+1F))*135F, (height-200F)+62F+d*65F, 120F, 16F);                 // [max(-1, -X)+1] vaut 1 si X = 0 et vaut 0 pour tout autre nombre > 0
                                if (mouseX > 17+30+u*135 && mouseX < 113-30+u*135                                                                       //  bouton du haut : véhicule 10*d+u
                                 && mouseY > (height-200)+17+10+d*65    && mouseY < (height-200)+63-10+d*65) {
                                     memo_d = d;
                                     memo_u = u;
                                }
                            }
                        }
                    }
                }
            }
            groupe = groupes[56];                                                                        //  composition
            groupe.Boutons[0].dessine_bouton( 970F, 543F+145F, 119F, 35F);
            groupe.Boutons[0].appui_bouton();
            groupe.Boutons[1].dessine_bouton(1100F, 543F+145F, 119F, 35F);
            groupe.Boutons[1].appui_bouton();
            groupe.Boutons[2].dessine_bouton(1230F, 543F+145F, 119F, 35F);
            groupe.Boutons[2].appui_bouton();
        }
        //------------------------------ boutons choix vehicule ----------------------------
        groupe = groupes[0];
        groupe.choix_vehicule_compo(x0-60F, y0-10F, l0+100F);
        groupe.Boutons[2].dessine_bouton(x0-60F, y0-250F, l0+180F, y0-50F);                            //  Passage au pupitre
        dessine_curseurHV(y0);                                                                        //  Curseur véhicule
        groupe = groupes[53];
        groupe.choix_bouton_actions_vehicule();
        groupe = groupes[54];
        groupe.choix_bouton_actions_filtres();
        groupe = groupes[55];
        groupe.choix_bouton_actions_decodeur();
        //-------------------------- affichage question  ------------------------------
        if (texte_information != null && !saisie_valide) {
            gestion.dessine_rectangle_bosse((width-500)/2F, (768F-300F)/2F, 500F, 300F);
            textFont(Courier14);
            imageMode(CORNER);
            if (texte_avertissement != null) {
                fill(NOIR);
                image(danger, width/2F-200F, height/2F-115F, 30F, 30F);
                textAlign(LEFT, CENTER);
                text(texte_avertissement, width/2F-160F, height/2F-100F);
            }
            fill(BLANC);
            textAlign(CENTER, CENTER);            
            text(texte_information, width/2F, height/2F-30F);
            textAlign(RIGHT, CENTER);
            text(texte_details, width/2F-2, height/2F+20F);
            if (groupes[53].Boutons[2].valide || groupes[56].Boutons[1].valide) {
                image(affiche_bleu, width/2F+2F, height/2F+8F, 30F, 30F);
            }
            if (groupes[56].Boutons[0].valide) {
                image(affiche_bleu, width/2F+2F, height/2F+8F, 200F, 30F);
            }
            textAlign(LEFT, CENTER);
            fill(NOIR);
            text(texte_saisi, width/2F+2F+20F, height/2F+20F);
            textAlign(CENTER, CENTER);
        }
        if (texte_information == null && texte_saisi != null && !texte_saisi.equals("")) {
            if (groupes[53].Boutons[2].valide) {
                groupes[53].Boutons[2].appui_bouton();
            }
            if (groupes[56].Boutons[0].valide) {
                groupes[56].Boutons[0].appui_bouton();
            }            
        }
        //---------------------------- gestion des filtres ----------------------------
        for (int i = 0; i < 5; i++) {
            //--------------------- choisir_filtre ------------------------
            groupe = groupes[54];
            if (groupe.Boutons[i+1].choix[i]) {
                groupe.Boutons[i+1].choisir_filtre(i);
            }
            //--------------------- afficher_filtre ------------------------
            if (groupe.Boutons[i+1].texte_choisi != null && !groupe.Boutons[i+1].choix[i]) {
                imageMode(CENTER);
                textFont(Courier14);
                textAlign(CENTER);
                fill(NOIR);
                if (groupe.Boutons[i+1].haut0) {
                    //-------------- affichage au dessus du bouton ------------
                    image(affiche_vert,                     groupe.Boutons[i+1].x+textWidth(groupe.Boutons[i+1].texte_affiche)/2F, 
                                                            groupe.Boutons[i+1].y+67F, textWidth(groupe.Boutons[i+1].texte_choisi)*1.2F, 15F);
                    text(groupe.Boutons[i+1].texte_choisi,  groupe.Boutons[i+1].x+(textWidth(groupe.Boutons[i+1].texte_affiche))/2F, 
                                                            groupe.Boutons[i+1].y+71F);
                } else {
                    //-------------- affichage en dessous du bouton ------------
                    image(affiche_vert,                     groupe.Boutons[i+1].x+textWidth(groupe.Boutons[i+1].texte_affiche)/2F, 
                                                            groupe.Boutons[i+1].y+48F, textWidth(groupe.Boutons[i+1].texte_choisi)*1.2F, 15F);
                    text(groupe.Boutons[i+1].texte_choisi,  groupe.Boutons[i+1].x+textWidth(groupe.Boutons[i+1].texte_affiche)/2F, 
                                                            groupe.Boutons[i+1].y+52F);
                }
            }
        }
    }
    //---------------------------------- dessine_curseurH() ---------------------------------------------------------
    void dessine_curseurHV(float _y0) {
        if (mouseX > x0+10  && mouseX < x0+l0-10
         && mouseY > _y0-20  && mouseY < _y0+20) {
            if (mousePressed) {
                dans_curseurH_vehicule = true;
            }
        }
        imageMode(CORNER);
        image(curseurH, curseur_left+largeur_curseur[0]-15F, _y0-10F, 30F, 20F);
    }
    //---------------------------------- dessine_curseurH() ---------------------------------------------------------
    void dessine_curseurHC(float _y0) {
        if (mouseX > x0+10  && mouseX < x0+l0-10
         && mouseY > _y0-20  && mouseY < _y0+20) {
            if (mousePressed) {
                dans_curseurH_compo = true;
            }
        }
        imageMode(CORNER);
        image(curseurH, curseur_left+largeur_curseur[1]-15F, _y0-10F, 30F, 20F);
    }
    //********************************************************************************************************
    //************************************ pupitre ***********************************************************
    void pupitre() {
        pupitre = true;
        groupe = groupes[52];
        groupe.Boutons[0].dessine_bouton(630F, 15F, 346F, vehicule.image_cote.height/2F);
        groupe.Boutons[0].appui_bouton();
        for (int ligne = 0; ligne < 4; ligne++) {
            for (int colonne = 0; colonne < 7; colonne++) {
                groupe.Boutons[7*ligne+colonne+1].dessine_bouton(20F+colonne*70F, 388F+ligne*97F, 50F, 50F);
                groupe.Boutons[7*ligne+colonne+1].appui_bouton();
            }
        }
        image(etiquette_fonctions, 150F, 310F, 204F, 40F);
        imageMode(CENTER);
        image(parchemin, 800F, 60F, 346F-35F, vehicule.image_cote.height/2F-10F);
        image(vehicule.image_cote, 800F, 70F, vehicule.image_cote.width/4F, vehicule.image_cote.height/4F);
        image(glissiere, 800F, 70F, 346F, vehicule.image_cote.height/2F); 
        imageMode(CORNER);
        //---------------- cran de vitesse ------------------
        PVector centre   = new PVector(1025F, 490F);
        PVector fleche   = new PVector(mouseX, mouseY);
        float   distance = centre.dist(fleche);
        cran = -int((-PI/4F+alpha)*127F*2F/PI);                                          //  cran de vitesse
        int CV29_bit5 = int(binary(infos_CV.CV[29], 8).substring(7-5, 7-5+1));
        int adresse_conduite = 0;
        if (CV29_bit5 == 0) {
            adresse_conduite = infos_CV.CV[1];
        } else {
            adresse_conduite = (infos_CV.CV[17]-192)*256+infos_CV.CV[18];
        }
        if (!demo) {
            port.write("<t 1 "+str(adresse_conduite)+" "+str(cran)+" 1>");
        }
        PVector manette_vitesse;
        PVector pointAR = new PVector(1025F-50F*cos(alpha), 490F-50F*sin(alpha));
        PVector pointAV = new PVector(1025F+(342F-50F)*cos(alpha), 490F+(342F-50F)*sin(alpha));
        float   largeur  = 98F;
        float   longueur = 342F;
        manette_vitesse  = new PVector(pointAV.x-pointAR.x, pointAV.y-pointAR.y);
        float angle      = manette_vitesse.heading();                                                                                          //  donne l'angle par rapport à l'horizontale
        //---------------------- dessine manette vitesse ---------------------   
        noFill();
        stroke(AQUA);
        strokeWeight(10);
        strokeCap(SQUARE);
        arc(1025F, 490F, 520F, 520F,-QUARTER_PI, QUARTER_PI);
        noStroke();
        fill(AQUA);
        imageMode(CENTER);
        textFont(Courier25);
        pushMatrix();                                                                                                                            // sauvegarde des transformations
            translate(1025F, 490F);
            rotate(QUARTER_PI);
            rect(255F, -5F, 40F, 10F);
            text("0", 305F, -6F);
        popMatrix();                                                                                                                            // restauration des transformations
        graduation_vitesse(30);
        graduation_vitesse(60);
        graduation_vitesse(90);
        graduation_vitesse(120);
        pushMatrix();                                                                                                                            // sauvegarde des transformations
            translate(1025F, 490F);
            rotate(-QUARTER_PI);
            rect(255F, -5F, 40F, 10F);
            text("127", 320F, -6F);
        popMatrix();                                                                                                                            // restauration des transformations
        imageMode(CORNER);
        pushMatrix();                                                                                                                            // sauvegarde des transformations
            translate((pointAV.x+pointAR.x)/2F, (pointAV.y+pointAR.y)/2F);
            rotate(angle);
            imageMode(CENTER);
            image(levier_axe, 0F, 0F, longueur, largeur);
            imageMode(CORNER);
        popMatrix();                                                                                                                            // restauration des transformations
        if (distance < 500F && mouseX > 1025F && mousePressed) {
            alpha = atan((mouseY-490F)/(mouseX-1025F));
            if(alpha > QUARTER_PI) {
                alpha = QUARTER_PI;
            } else {
                if (alpha < -QUARTER_PI) {
                    alpha = -QUARTER_PI;
                }
            }
        }
        //***************************************** Inverseur **********************************************
        PVector extremite_inverseur = new PVector(975F+(80F-8F)*cos(alpha_i), 650F+(80F-8F)*sin(alpha_i));
        fleche             = new PVector(mouseX, mouseY);
        float   distance_i = extremite_inverseur.dist(fleche);
        PVector manette_inverseur;
        PVector pointAV_i  = new PVector(975F-8F*cos(alpha_i), 650F-8F*sin(alpha_i));
        PVector pointAR_i  = new PVector(975F+(80F-8F)*cos(alpha_i), 650F+(80F-8F)*sin(alpha_i));
        float   largeur_i  = 17F;
        float   longueur_i = 80F;
        manette_inverseur  = new PVector(pointAV_i.x-pointAR_i.x, pointAV_i.y-pointAR_i.y);
        float angle_i      = manette_inverseur.heading();                                                                                         //  donne l'angle par rapport à l'horizontale
        //---------------------- dessine manette inverseur ---------------------
        noFill();
        stroke(BLANC);
        strokeWeight(10);
        strokeCap(SQUARE);
        arc(975F, 650F, 125F, 125F, -QUARTER_PI, QUARTER_PI);
        noStroke();
        fill(BLANC);
        imageMode(CENTER);
        textFont(Courier25);
        pushMatrix();                                                                                                                            // sauvegarde des transformations
            translate(975F, 650F);
            rotate(0);
            rect(57F, -5F, 30F, 10F);
            text("0", 100F, -6F);
        popMatrix();                                                                                                                            // restauration des transformations
        pushMatrix();                                                                                                                            // sauvegarde des transformations
            translate(975F, 650F);
            rotate(-QUARTER_PI);
            rect(57F, -5F, 30F, 10F);
            text("AV", 110F, -6F);
        popMatrix();                                                                                                                            // restauration des transformations
        pushMatrix();                                                                                                                            // sauvegarde des transformations
            translate(975F, 650F);
            rotate(QUARTER_PI);
            rect(57F, -5F, 30F, 10F);
            text("AR", 110F, -6F);
        popMatrix();                                                                                                                            // restauration des transformations
        imageMode(CORNER);
        pushMatrix();                                                                                                                            // sauvegarde des transformations
            translate((pointAV_i.x+pointAR_i.x)/2F, (pointAV_i.y+pointAR_i.y)/2F);
            rotate(angle_i);
            imageMode(CENTER);
            image(levier_inverseur, 0F, 0F, longueur_i, largeur_i);
            imageMode(CORNER);
        popMatrix();                                                                                                                            // restauration des transformations
        if (distance_i < (80F-8F) && mousePressed) {
            if (top == 1) {
                inverse = (inverse+1) % 4;
            }
            switch (inverse) {
                case 0:
                    alpha_i = 0;
                    break;                
                case 1:
                    alpha_i = -QUARTER_PI;
                    break;                
                case 2:
                    alpha_i = 0;
                    break;                
                case 3:
                    alpha_i = QUARTER_PI;
                    break;                
            }
        }
        //************************************ compteur de vitesse *****************************************
        PVector aiguille_vitesse;
        PVector pointAR_vi  = new PVector(730F-37F*cos(alpha_vi), 463F-37F*sin(alpha_vi));
        PVector pointAV_vi  = new PVector(730F+(182F-37F)*cos(alpha_vi), 463F+(182F-37F)*sin(alpha_vi));
        float   largeur_vi  = 27F;
        float   longueur_vi = 182F;
        aiguille_vitesse   = new PVector(pointAV_vi.x-pointAR_vi.x, pointAV_vi.y-pointAR_vi.y);
        float angle_vi      = aiguille_vitesse.heading();                                                                                          //  donne l'angle par rapport à l'horizontale
        //---------------------- dessine compteur vitesse ---------------------   
        pushMatrix();                                                                                                                            // sauvegarde des transformations
            translate((pointAV_vi.x+pointAR_vi.x)/2F, (pointAV_vi.y+pointAR_vi.y)/2F);
            rotate(angle_vi);
            imageMode(CENTER);
            image(aiguille_compteur, 0F, 0F, longueur_vi, largeur_vi);
            imageMode(CORNER);
        popMatrix();                                                                                                                            // restauration des transformations
        // Tension_maxi = 14,5V (ici) = niveau 255 par définition.
        // Démarrage à CV[2] = 38 (ici), c'est à dire que tant qu'on a pas atteint Tension_maxi*CV[2]/255, vitesse = 0
        // V_maxi à CV[5], c'est à dire qu'on atteint la vitesse maximale 120 km/h (ici) au cran CV[5] = 182 (ici), c'est à dire à la tension : Tension_maxi*CV[5]/255
        // 1°) Pour vitesse = 200 km/h, l'angle est à 3F*HALF_PI par rapport à 0 => angle = vitesse*3F*HALF_PI/200F
        // 2°) Entre 0 et 120 km/h, on a 128 crans par définition => 1 cran = 120/128 km/h => vitesse = cran*120/128
        // Inertie : 
        
        alpha_vi = cran*(infos_CV.v_reelle)/128F*3F*HALF_PI/200F-5F*QUARTER_PI;
        //************************************ voltmètre *****************************************
        PVector aiguille_vo;
        PVector pointAR_vo  = new PVector(174F-30F*cos(alpha_vo), 117F-30F*sin(alpha_vo));
        PVector pointAV_vo  = new PVector(174F+(158F-30F)*cos(alpha_vo), 117F+(158F-30F)*sin(alpha_vo));
        float   largeur_vo  = 9F;
        float   longueur_vo = 158F;
        aiguille_vo         = new PVector(pointAV_vo.x-pointAR_vo.x, pointAV_vo.y-pointAR_vo.y);
        float angle_vo      = aiguille_vo.heading();                                                                                          //  donne l'angle par rapport à l'horizontale
        //---------------------- dessine compteur voltmètre ---------------------   
        pushMatrix();                                                                                                                            // sauvegarde des transformations
            translate((pointAV_vo.x+pointAR_vo.x)/2F, (pointAV_vo.y+pointAR_vo.y)/2F);
            rotate(angle_vo);
            imageMode(CENTER);
            image(aiguille_va, 0F, 0F, longueur_vo, largeur_vo);
            imageMode(CORNER);
        popMatrix();                                                                                                                            // restauration des transformations
        alpha_vo = -cran*10F/128F*3F*HALF_PI/32.1F-5F*QUARTER_PI-0.05F;
        image(triangle_va, 154F, 97F, 40F, 19F);
        //************************************ ampèremètre *****************************************
        PVector aiguille_a;
        PVector pointAR_a  = new PVector(457F-30F*cos(alpha_a), 117F-30F*sin(alpha_a));
        PVector pointAV_a  = new PVector(457F+(158F-30F)*cos(alpha_a), 117F+(158F-30F)*sin(alpha_a));
        float   largeur_a  = 9F;
        float   longueur_a = 158F;
        aiguille_a         = new PVector(pointAV_a.x-pointAR_a.x, pointAV_a.y-pointAR_a.y);
        float angle_a      = aiguille_a.heading();                                                                                          //  donne l'angle par rapport à l'horizontale
        //---------------------- dessine compteur ampères ---------------------   
        pushMatrix();                                                                                                                            // sauvegarde des transformations
            translate((pointAV_a.x+pointAR_a.x)/2F, (pointAV_a.y+pointAR_a.y)/2F);
            rotate(angle_a);
            imageMode(CENTER);
            image(aiguille_va, 0F, 0F, longueur_a, largeur_a);
            imageMode(CORNER);
        popMatrix();                                                                                                                            // restauration des transformations
        alpha_a = -cran*10F/128F*3F*HALF_PI/32.1F-5F*QUARTER_PI-0.07F;
        image(triangle_va, 437F, 97F, 40F, 19F);
        //****************************************** Nixies **********************************************
        imageMode(CORNER);
        //------------------------ affichage adresse -------------------
        CV29_bit5 = int(binary(infos_CV.CV[29], 8).substring(7-5, 7-5+1));                                                //(7-n°bit, 7-n°bit+1) si on démarre à 0
        int adresse   = 0;
        if (CV29_bit5 == 0) {
            adresse = infos_CV.CV[1];
        } else {
            adresse = (infos_CV.CV[17]-192)*256+infos_CV.CV[18];
        }
        nixie[4] = adresse-10*int(adresse/10+.5);
        adresse  = (adresse-nixie[4])/10;
        nixie[3] = adresse-10*int(adresse/10+.5);
        adresse  = (adresse-nixie[3])/10;
        nixie[2] = adresse-10*int(adresse/10+.5);
        adresse  = (adresse-nixie[2])/10;
        nixie[1] = adresse-10*int(adresse/10+.5);
        adresse  = (adresse-nixie[1])/10;
        nixie[0] = adresse-10*int(adresse/10+.5);
        image(etiquette_adresse, 715F, 240F, 179F, 30F);
        affiche_nixie(5, 630F, 140F);
        //----------------------- affichage crans de vitesse --------------------
        nixie[2] = cran-10*int(cran/10+.5);
        cran     = (cran-nixie[2])/10;
        nixie[1] = cran-10*int(cran/10+.5);
        cran     = (cran-nixie[1])/10;
        nixie[0] = cran-10*int(cran/10+.5);            
        image(etiquette_cran, 1110F, 240F, 100F, 30F);
        affiche_nixie(3, 1050F, 140F);
    }
    //---------------------------------- affichage_nixie() ------------------------------------
    void affiche_nixie (int _nb_tubes, float _x_tube, float _y_tube) {
        for (int i = 0; i < _nb_tubes; i++) {            
            switch(nixie[i]) {
                case 0:
                    image(nixie_0, _x_tube+i*70F, _y_tube, 66F, 93F);
                    break;
                case 1:
                    image(nixie_1, _x_tube+i*70F, _y_tube, 66F, 93F);
                    break;
                case 2:
                    image(nixie_2, _x_tube+i*70F, _y_tube, 66F, 93F);
                    break;
                case 3:
                    image(nixie_3, _x_tube+i*70F, _y_tube, 66F, 93F);
                    break;
                case 4:
                    image(nixie_4, _x_tube+i*70F, _y_tube, 66F, 93F);
                    break;
                case 5:
                    image(nixie_5, _x_tube+i*70F, _y_tube, 66F, 93F);
                    break;
                case 6:
                    image(nixie_6, _x_tube+i*70F, _y_tube, 66F, 93F);
                    break;
                case 7:
                    image(nixie_7, _x_tube+i*70F, _y_tube, 66F, 93F);
                    break;
                case 8:
                    image(nixie_8, _x_tube+i*70F, _y_tube, 66F, 93F);
                    break;
                case 9:
                    image(nixie_9, _x_tube+i*70F, _y_tube, 66F, 93F);
                    break;
                default :
                    image(nixie_10, _x_tube+i*70F, _y_tube, 66F, 93F);
                    break;
            }
        }
        if (nixie[0] == 0) {
            image(nixie_10, _x_tube+0*70F, _y_tube, 66F, 93F);
            if (nixie[1] == 0) {
                image(nixie_10, _x_tube+1*70F, _y_tube, 66F, 93F);
                if (_nb_tubes != 3 && nixie[2] == 0) {
                    image(nixie_10, _x_tube+2*70F, _y_tube, 66F, 93F);
                    if (_nb_tubes != 3 && nixie[3] == 0) {
                        image(nixie_10, _x_tube+3*70F, _y_tube, 66F, 93F);
                        if (_nb_tubes != 3 && nixie[4] == 0) {
                            image(nixie_10, _x_tube+4*70F, _y_tube, 66F, 93F);
                        }
                    }
                }
            }
        }
        
    }
    //---------------------------------- graduation_vitesse() --------------------------------------------------
    void graduation_vitesse(int _vitesse) {
        pushMatrix();                                                                                                                            // sauvegarde des transformations
            translate(1025F, 490F);
            rotate(QUARTER_PI-PI*(_vitesse+1F)/256F);
            rect(255F, -5F, 40F, 10F);
            if (_vitesse < 10) {
                text(str(_vitesse), 305F, -6F);
            } else {
                if (_vitesse < 100) {
                    text(str(_vitesse), 312F, -6F);
                } else {
                    text(str(_vitesse), 320F, -6F);
                }
            }
        popMatrix();                                                                                                                            // restauration des transformations
    }
    //*********************************************************************************************************************************************************************
    //************************************************ décodeurs **********************************************************************************************************
    //--------------------------- liste_decodeurs() -----------------------
    void liste_decodeurs() {
        tous_decodeurs.clear();
        for (int i = 0; i < NB_DECODEURS; i++) {
            if (decodeurs[i] != null) {
                tous_decodeurs.add(decodeurs[i]);
            }
        }
    }   
    //--------------------------- liste_fabricants() -----------------------
    void liste_fabricants() {
        tous_fabricants.clear();
        for (Decodeur dec0 : tous_decodeurs) {
            if (dec0 != null) {                
                boolean trouve = false;
                for (String fab0 : tous_fabricants) {
                    if (fab0.equals(dec0.nom_fabricant)) {
                        trouve = true;
                        break;
                    }
                }
                if (!trouve) {
                    tous_fabricants.append(dec0.nom_fabricant);
                    if (largeur_fabricant < (dec0.nom_fabricant.length())*ZOOM) {
                        largeur_fabricant = (dec0.nom_fabricant.length())*ZOOM;
                    }
                }
            }
        }
        tous_fabricants.sort();
    }   
    //--------------------------- liste_familles() -----------------------
    void liste_familles() {
        toutes_familles.clear();
        for (Decodeur dec0 : tous_decodeurs) {
            if (dec0 != null) {
                boolean trouve = false;
                for (String fam0 : toutes_familles) {
                    if (fam0.equals(dec0.nom_famille)) {
                        trouve = true;
                        break;
                    }
                }
                if (!trouve) {
                    toutes_familles.append(dec0.nom_famille);
                    int fab = dec0.nom_famille.indexOf("/");
                    if (largeur_famille < (dec0.nom_famille.substring(fab+1, dec0.nom_famille.length()).length())*ZOOM) {
                        largeur_famille = (dec0.nom_famille.substring(fab+1, dec0.nom_famille.length()).length())*ZOOM;
                    }
                }
            }
        }
        toutes_familles.sort();
    }   
    //--------------------------- liste_modeles() -----------------------
    void liste_modeles() {
        tous_modeles.clear();
        for (Decodeur dec0 : tous_decodeurs) {
            if (dec0 != null) {
                boolean trouve = false;
                for (String mod0 : tous_modeles) {
                    if (mod0.equals(dec0.nom_modele)) {
                        trouve = true;
                        break;
                    }
                }
                if (!trouve) {
                    tous_modeles.append(dec0.nom_modele);
                    int mod = dec0.nom_modele.indexOf("//");
                    if (largeur_modele < (dec0.nom_modele.substring(mod+2, dec0.nom_modele.length()).length())*ZOOM) {
                        largeur_modele = (dec0.nom_modele.substring(mod+2, dec0.nom_modele.length()).length())*ZOOM;
                    }
                }
            }
        }
        tous_modeles.sort();
    }  
    //-------------------- dessine_fabricants() ------------------------------
    void dessine_fabricants() {
        affiche_en_tete = false;
        textFont(Courier14);
        dessine_les_fabricants = true;
        dessine_rectangle_creux(GRIS, 10F, 10F, largeur_fabricant, 4F+min(tous_fabricants.size(), 49)*15F);
        //------------------------------ boutons haut_bas ----------------------------
        textFont(Courier14);
        textAlign(LEFT);
        int compte_fabricants = -1;
        groupe = groupes[50];
        if (tous_fabricants.size() > 49) {
            if (delta0 == 0) {
                groupe.Boutons[1].dessine_bouton(10F+largeur_fabricant-25F, 4F+49F*15F-17F, 20F, 20F);
                groupe.Boutons[1].appui_bouton();
                if (groupe.Boutons[1].bas0) {
                    delta0 = tous_fabricants.size()-49;
                    compte_fabricants = delta0;
                    groupe.Boutons[0].haut0 = false;
                }
            } else {
                groupe.Boutons[0].dessine_bouton(10F+largeur_fabricant-25F, 15F, 20F, 20F);                
                groupe.Boutons[0].appui_bouton();
                if (groupe.Boutons[0].haut0) {
                    delta0 = 0;
                    compte_fabricants = -1;
                    groupe.Boutons[1].bas0 = false;
                }
            }
        }
        //--------------------------- affichage des fabricants ----------------------------
        for (String fab0 : tous_fabricants) {
            compte_fabricants++;
            if (compte_fabricants-delta0 < 49) {
                for (Decodeur dec0 : tous_decodeurs) {
                    dec0.onglet_choisi = null;
                    if (dec0.nom_fabricant.equals(fab0)) {
                        if (mouseX > 10                               && mouseX < 10+largeur_fabricant-25
                         && mouseY > 10+15*(compte_fabricants-delta0) && mouseY < 24+15*(compte_fabricants-delta0)) {
                            if (top == 1) {
                                fabricant_choisi   = fab0;
                                infos_CV.fabricant = fabricant_choisi;
                                ligne_fabricant    = compte_fabricants;
                                famille_choisie    = ".";
                                ligne_famille      = -1;
                                break;
                            } else {
                                fill(NOIR);
                                imageMode(CORNER);
                                image(affiche_bleu, 13, 12+15*(compte_fabricants-delta0), (fab0.length())*ZOOM, 15);
                            }
                        } else {
                            fill(BLANC);
                        }
                    }
                }
                strokeWeight(1);
                if (delta0 == 0 && compte_fabricants < 49) {
                    text(fab0, 15, 24+15*compte_fabricants);
                }
                if (delta0 != 0 && compte_fabricants > delta0-1) {            
                    text(fab0, 15, 24+15*(compte_fabricants-delta0));
                }
            }
        }
        if (ligne_fabricant != -1) {
            imageMode(CORNER);
            image(affiche_vert, 13, 12+15*(ligne_fabricant-delta0), (fabricant_choisi.length())*ZOOM, 15);            
            strokeWeight(1);
            fill(NOIR);
            text(fabricant_choisi, 15, 24+15*(ligne_fabricant-delta0));
        }
    }
    //-------------------- dessine_familles() ------------------------------
    void dessine_familles() {
        textFont(Courier14);
        textAlign(LEFT);
        if (ligne_fabricant != -1) {
            dessine_les_familles   = true;
            int compte_familles = 0;
            for (String fam0 : toutes_familles) {
                int fab = fam0.indexOf("/");
                if (fam0.substring(0, fab).equals(fabricant_choisi)) {
                    compte_familles++;
                }
            }
            dessine_rectangle_creux(GRIS, 20+largeur_fabricant, 10, largeur_famille, 4F+min(compte_familles, 49)*15F);
            //--------------------- calcul de la largeur du cadre famille -----------------------------
            largeur_famille = 0;
            for (String fam0 : toutes_familles) {
                int fab = fam0.indexOf("/");
                if (fam0.substring(0, fab).equals(fabricant_choisi)) {
                    for (Decodeur dec0 : tous_decodeurs) {
                        if (dec0 != null && dec0.nom_famille.equals(fam0)) {
                            if (largeur_famille < (dec0.nom_famille.substring(fab+1).length()+1)*ZOOM) {
                                largeur_famille = (dec0.nom_famille.substring(fab+1).length()+1)*ZOOM;
                            }
                        }
                    }                        
                }
            }
            //-------------------------------affichage des familles sélectionées -----------------------
            compte_familles = -1;
            for (String fam0 : toutes_familles) {
                int fab = fam0.indexOf("/");
                if (fam0.substring(0, fab).equals(fabricant_choisi)) {
                    compte_familles++;
                    for (Decodeur dec0 : tous_decodeurs) {
                        if (dec0 != null && dec0.nom_famille.equals(fam0)) {
                            if (mouseX > 20+largeur_fabricant  && mouseX < 20+largeur_fabricant+largeur_famille
                             && mouseY > 10+15*compte_familles && mouseY < 24+15*compte_familles) {
                                if (top == 1) {
                                    famille_choisie = fam0;
                                    infos_CV.famille = famille_choisie.substring(fab+1);
                                    ligne_famille   = compte_familles;
                                    modele_choisi   = ".";
                                    ligne_modele    = -1;
                                    top = 2;
                                } else {
                                    fill(NOIR);
                                    imageMode(CORNER);
                                    image(affiche_bleu, 23+largeur_fabricant, 12+15*compte_familles, (fam0.substring(fab+1).length())*ZOOM, 15);
                                }
                            } else {
                                fill(BLANC);
                            }
                        }
                    }                        
                    strokeWeight(1);
                    text(fam0.substring(fab+1), 25+largeur_fabricant, 24+15*compte_familles);
                }
            }
            if (ligne_famille != -1) {
                int fab = famille_choisie.indexOf("/");
                imageMode(CORNER);
                image(affiche_vert, 23+largeur_fabricant, 12+15*ligne_famille, (famille_choisie.substring(fab+1).length())*ZOOM, 15);
                strokeWeight(1);
                fill(NOIR);
                text(famille_choisie.substring(fab+1), 25+largeur_fabricant, 24+15*ligne_famille);
            }
        }
    }
    //-------------------- dessine_modeles() ------------------------------
    void dessine_modeles() {
        textFont(Courier14);
        textAlign(LEFT);
        if (ligne_famille != -1) {
            dessine_les_modeles = true;
            int compte_modeles = -1;
            int compte_depart  = -1;
            int ligne_depart   = 0;
            for (String mod0 : tous_modeles) {
                compte_depart++;
                int mod = mod0.indexOf("//");
                if (mod0.substring(0, mod).equals(famille_choisie)) {
                    if (compte_modeles == -1) {
                        ligne_depart = compte_depart;
                    }
                    compte_modeles++;
                }
            }
            dessine_rectangle_creux(GRIS, 30+largeur_fabricant+largeur_famille, 10, largeur_modele, 4F+min(compte_modeles+1, 49)*15F);
            //------------------------------ boutons haut_bas ----------------------------
            groupe = groupes[51];
            if (compte_modeles > 49) {
                if (delta2 == 0) {
                    groupe.Boutons[1].dessine_bouton(30+largeur_fabricant+largeur_famille+largeur_modele-25F, 4F+49F*15F-17F, 20F, 20F);
                    groupe.Boutons[1].appui_bouton();
                    if (groupe.Boutons[1].bas2) {
                        delta2 = compte_modeles-48;
                        compte_modeles = delta2;
                        groupe.Boutons[0].haut2 = false;
                    }
                } else {
                    groupe.Boutons[0].dessine_bouton(30+largeur_fabricant+largeur_famille+largeur_modele-25F, 15F, 20F, 20F);                
                    groupe.Boutons[0].appui_bouton();
                    if (groupe.Boutons[0].haut2) {
                        delta2 = 0;
                        compte_modeles = -1;
                        groupe.Boutons[1].bas2 = false;
                    }
                }
            }
            //--------------------- calcul de la largeur du cadre modeles -----------------------------
            largeur_modele = 0;
            for (String mod0 : tous_modeles) {
                int mod = mod0.indexOf("//");
                if (mod0.substring(0, mod).equals(famille_choisie)) {
                    for (Decodeur dec0 : tous_decodeurs) {
                        if (dec0 != null && dec0.nom_modele.equals(mod0)) {
                            if (largeur_modele < (dec0.nom_modele.substring(mod+2).length()+1)*ZOOM) {
                                largeur_modele = (dec0.nom_modele.substring(mod+2).length()+1)*ZOOM;
                            }
                        }
                    }                        
                }
            }
            //-------------------------------affichage des modèles sélectionés -----------------------
            textFont(Courier14);
            textAlign(LEFT);
            compte_depart  = -1;
            compte_modeles = -1;
            for (String mod0 : tous_modeles) {
                compte_depart++;
                if (compte_depart >= ligne_depart) {
                    int mod = mod0.indexOf("//");
                                                                                                  //println(mod0.substring(0, mod), famille_choisie);
                    if (mod0.substring(0, mod).equals(famille_choisie)) {
                        if (compte_modeles-delta2 < 49) {
                            compte_modeles++;
                            for (Decodeur dec0 : tous_decodeurs) {
                                if (dec0 != null && dec0.nom_modele.equals(mod0)) {
                                    if (mouseX > 30+largeur_fabricant+largeur_famille  && mouseX < 30+largeur_fabricant+largeur_famille+largeur_modele-25
                                     && mouseY > 10+15*(compte_modeles-delta2)         && mouseY < 24+15*(compte_modeles-delta2)) {
                                        if (top == 1) {
                                            modele_choisi   = mod0;
                                            infos_CV.modele = modele_choisi.substring(mod+2);
                                            ligne_modele    = compte_modeles;
                                            decodeur_choisi = dec0;
                                            top = 2;
                                        } else {
                                            fill(NOIR);
                                            imageMode(CORNER);
                                            image(affiche_bleu, 33+largeur_fabricant+largeur_famille, 12+15*(compte_modeles-delta2), (mod0.substring(mod+2, mod0.length()-2).length())*ZOOM, 15);
                                            break;
                                        }
                                    } else {
                                        fill(BLANC);
                                    }
                                }
                            }                        
                            strokeWeight(1);
                            if (delta2 == 0 && compte_modeles < 49) {
                                text(mod0.substring(mod+2, mod0.length()), 35+largeur_fabricant+largeur_famille, 24+15*compte_modeles);
                            }
                            if (delta2 != 0 && compte_modeles > delta2-1) {            
                                text(mod0.substring(mod+2, mod0.length()), 35+largeur_fabricant+largeur_famille, 24+15*(compte_modeles-delta2));
                            }
                        }
                    }
                }
            }
            if (ligne_modele != -1) {
                int mod = modele_choisi.indexOf("//");
                imageMode(CORNER);
                image(affiche_vert, 33+largeur_fabricant+largeur_famille, 12+15*ligne_modele, (modele_choisi.substring(mod+2).length())*ZOOM, 15);            
                strokeWeight(1);
                fill(NOIR);
                text(modele_choisi.substring(mod+2), 37+largeur_fabricant+largeur_famille, 24+15*ligne_modele);
                //--------------- sauvegarde des nouvelles informations --------------
                sauve_table_Infos_CV();
                sauvegarde_infos_CV();
                for (String mod0 : tous_modeles) {
                    mod = mod0.indexOf("//");
                    if (mod0.substring(0, mod).equals(famille_choisie)) {
                        tous_onglets.clear();
                        int   nb_onglets     = decodeur_choisi.Onglets.length;
                        for (int i = 0; i < nb_onglets ; i++) {
                            tous_onglets.add(decodeur_choisi.Onglets[i]);
                        }
                    }
                }
            }            
        }
    }
    //-------------------- dessine_decodeur() ------------------------------
    void dessine_decodeur() {
        if (ligne_modele != -1) {
            //----------------------------- récupération : fabricant, modèle, référence --------------
            if (one_shot) {
                infos_CV = toutes_infos_CV.get(vehicule.ID_CV);
                //dessine_en_tete();
                for (Decodeur dec0 : tous_decodeurs) {
                    if (dec0 != null && dec0.nom_modele.equals(modele_choisi)) {
                        dec0.calcule_donnees();
                        for (Zone zon0 : dec0.toutes_zones) {
                            if (zon0.nom_zone.equals("Fiche")) {
                                one_shot = false;
                                dec0.onglet_choisi = zon0.nom_zone;
                                textFont(Courier14);
                                dessine_en_tete();
                                dec0.reordonne_onglets();
                                dec0.grand_onglet(zon0.nom_zone);
                                //-------------- insertion du véhicule ----------
                                dessine_rectangle_creux(vehicule.couleur, 20F, 640F, 300F, 90F);
                                imageMode(CENTER);
                                image(vehicule.image_cote, 20F+300F/2F, 630F+100F/2F, vehicule.image_cote.width/4F, vehicule.image_cote.height/4F);
                                copie_ecran();
                                break;
                            }
                        }
                        break;
                    }
                }
            }
        }
    }
    //------------------- dessine_en_tete() -----------------------------
    void dessine_en_tete() {
        affiche_en_tete = true;
        int fab = famille_choisie.indexOf("/");
        int mod = modele_choisi.indexOf("//");
        float largeur_fabricant = fabricant_choisi.length()*ZOOM;
        float largeur_famille   = famille_choisie.substring(fab+1).length()*ZOOM;
        float largeur_modele    = modele_choisi.substring(mod+2).length()*ZOOM;
        imageMode(CORNER);
        image(fond_alu, 0, 0, width,height);
        image(affiche_vert, 13F,                                   10F, largeur_fabricant, 15F);            
        image(affiche_vert, 23F+largeur_fabricant,                 10F, largeur_famille,   15F);
        image(affiche_vert, 52F+largeur_fabricant+largeur_famille, 10F, largeur_modele,    15F);            
        fill(NOIR);
        textFont(Courier14);
        textAlign(LEFT, TOP);
        text(fabricant_choisi,                 17F,                                   9F);
        text(famille_choisie.substring(fab+1), 27F+largeur_fabricant,                 9F);
        text(modele_choisi.substring(mod+2),   56F+largeur_fabricant+largeur_famille, 9F);
    }
    //----------------------------- copie_ecran() -------------------------------
    void copie_ecran() {
        ecran      = createImage(width, height, RGB);                                                 //  ce sera l'image de l'écran
        //------------ calcule l'image du fond d'ecran ---------------------
        ecran.loadPixels();                                                                           //  prépare la variable écran
        loadPixels();                                                                                 //  charge l'écran complet dans la variable Pixels()
        for (int j = 0; j < pixels.length; j++) {
            ecran.pixels[j] = pixels[j];                                                              //  prépare la copie tous les pixels de l'écran dans la variable écran                                                                                               
        }
        ecran.updatePixels();                                                                         //  met à jours la variable écran. A noter que cette variable écran n'a pas de trains
    }
    //----------------------------- dessine_rectangle_creux() -------------------------
    void dessine_rectangle_creux(color _couleur, float _x0, float _y0, float _l0, float _h0) {
        float e = 1.3F;
        noStroke();
        fill(_couleur);
        rect(_x0, _y0, _l0, _h0);
        noFill();
        strokeWeight(2F*e);
        stroke(BLANC);
        rect(_x0, _y0, _l0, _h0);
        noStroke();
        fill(NOIR);
        quad(_x0-e, _y0-e,   _x0+_l0+e,  _y0-e,  _x0+_l0-e, _y0+e,  _x0+e, _y0+e);
        quad(_x0-e, _y0-e,   _x0-e,  _y0+_h0+e,  _x0+e, _y0+_h0-e,  _x0+e, _y0+e);
    }
    //----------------------------- dessine_rectangle_bosse() -------------------------
    void dessine_rectangle_bosse(float _x0, float _y0, float _l0, float _h0) {
        float e = 1.3F;
        imageMode(CORNER);
        image(fond_alu1, _x0, _y0, _l0, _h0);
        noFill();
        strokeWeight(2F*e);
        stroke(NOIR);
        rect(_x0, _y0, _l0, _h0);
        noStroke();
        fill(BLANC);
        quad(_x0-e, _y0-e,   _x0+_l0+e,  _y0-e,  _x0+_l0-e, _y0+e,  _x0+e, _y0+e);
        quad(_x0-e, _y0-e,   _x0-e,  _y0+_h0+e,  _x0+e, _y0+_h0-e,  _x0+e, _y0+e);
    }
}
