//*********************************************************************************************************************
//----------------------------- creation_table_Vehicules() ---------------------------------
void creation_table_Vehicules() {
    Vehicules = new Table();
    Vehicules.addColumn("ID");
    Vehicules.addColumn("ID_CV");
    Vehicules.addColumn("nom");
    Vehicules.addColumn("image");
    Vehicules.addColumn("marque");
    Vehicules.addColumn("ref");
    Vehicules.addColumn("htamp");
    Vehicules.addColumn("couleur");
    Vehicules.addColumn("echelle");
    Vehicules.addColumn("moteur");
    Vehicules.addColumn("date");
    Vehicules.addColumn("CV106");
}
//----------------------------- charge_table_Vehicules() ------------------------------------
void charge_table_Vehicules() {
    Vehicules = loadTable(Repertoire_Communs+"TSV/Vehicules.tsv", "header, tsv");
    
    int compte_lignes = -1;
    toutes_marques.clear();
    for (TableRow row : Vehicules.rows()) {
        compte_lignes++;
        int     _ID        = row.getInt(              "ID");
        int     _ID_CV     = row.getInt(              "ID_CV");
        String  _nom       = row.getString(           "nom");
        String  _image_t   = row.getString(           "image");
        String  _marque    = row.getString(           "marque");
        String  _ref       = row.getString(           "ref");
        int     _htamp     = row.getInt(              "htamp");
        color   _couleur   = unhex("FF"+row.getString("couleur").substring(1));                                                        //  unhex(String) -> int. String doit démarrer par FF. Il faut donc remplacer le 1er caractère (#)
        String  _echelle   = row.getString(           "echelle");
        boolean _moteur    = boolean(row.getInt(      "moteur"));
        String  _date      = row.getString(           "date");
        int     _CV106     = row.getInt(              "CV106");
        
        Vehicule veh0   = new Vehicule();
        veh0.ID         = _ID;
        veh0.ID_CV      = _ID_CV;
        veh0.nom        = _nom;
        veh0.image_t    = _image_t;
        veh0.image_cote = loadImage(Repertoire_Communs+"Vehicules/"+_image_t);
        veh0.marque     = _marque;
        veh0.ref        = _ref;
        veh0.htamp      = _htamp;
        veh0.moteur     = _moteur;
        if (_moteur) {
            veh0.couleur    = unhex("FF808080");
        } else {
            veh0.couleur    = _couleur;
        }
        veh0.echelle    = _echelle;
        veh0.date       = _date;
        veh0.CV106      = _CV106;
        veh0.rang       = compte_lignes;
        veh0.filtre     = true;
        tous_vehicules_complet.add(veh0);
        tous_vehicules_filtres.add(veh0);
        tous_vehicules.add(veh0);
        //---------------------- liste des marques ----------------------
        boolean trouve = false;
        for (String marq0 : toutes_marques) {
            if (veh0.marque.equals(marq0)) {
                trouve = true;
                break;
            }
        }
        if (!trouve) {
            toutes_marques.append(veh0.marque);
        }
        toutes_marques.sort();
        
    }
}
//------------------------------ sauve_table_Vehicules() ---------------------------------------------------------
void sauve_table_Vehicules() {
    Vehicules.clearRows();    
    TableRow newRow;    
    int compte_vehicules = -1;
    for (Vehicule veh0 : tous_vehicules_complet) {
        newRow = Vehicules.addRow();
        compte_vehicules++;
        Vehicules.setInt(   compte_vehicules, "ID",         veh0.ID);
        Vehicules.setInt(   compte_vehicules, "ID_CV",      veh0.ID_CV);
        Vehicules.setString(compte_vehicules, "nom",        veh0.nom);
        Vehicules.setString(compte_vehicules, "image",      veh0.image_t);
        Vehicules.setString(compte_vehicules, "marque",     veh0.marque);
        Vehicules.setString(compte_vehicules, "ref",        veh0.ref);
        Vehicules.setInt(   compte_vehicules, "htamp",      veh0.htamp);
        Vehicules.setString(compte_vehicules, "couleur",    "#"+hex(color(veh0.couleur)).substring(2));                              //  hex(color) -> String. String doit démarrer par #. Il faut donc remplacer les deux 1ers caractères (FF)
        Vehicules.setString(compte_vehicules, "echelle",    veh0.echelle);
        Vehicules.setInt(   compte_vehicules, "moteur",     int(veh0.moteur));
        Vehicules.setString(compte_vehicules, "date",       veh0.date);
        Vehicules.setInt(   compte_vehicules, "CV106",      veh0.CV106);
    }        
    saveTable(Vehicules, Repertoire_Communs+"TSV/Vehicules.tsv");
}
//----------------------------- maj_date() ---------------------------------
void maj_date() {    
    String str_ye = str(year());
    String str_mo = str(100+month()).substring(1,3);
    String str_da = str(100+day()).substring(1,3);
    String str_ho = str(100+hour()).substring(1,3);
    String str_mi = str(100+minute()).substring(1,3);
    String str_se = str(100+second()).substring(1,3);
    date = str_ye+"_"+str_mo+"_"+str_da+"__"+str_ho+"_"+str_mi+"_"+str_se;
}
//*********************************************************************************************************************
//----------------------------- creation_table_infos_CV() ---------------------------------
void creation_table_Infos_CV() {
    Infos_CV = new Table();
    Infos_CV.addColumn("ID_CV");
    Infos_CV.addColumn("fabricant");
    Infos_CV.addColumn("famille");
    Infos_CV.addColumn("modele");
    Infos_CV.addColumn("v_reelle");
    Infos_CV.addColumn("frein");
    Infos_CV.addColumn("elan");
    for (int i = 0; i < 5; i++) {
        Infos_CV.addColumn("P"+str(i));
    }
    for (int i = 1; i < 201; i++) {
        Infos_CV.addColumn("CV"+str(i));
    }
}
//----------------------------- charge_table_Vehicules() ------------------------------------
void charge_table_Infos_CV() {
    Infos_CV = loadTable(Repertoire_Communs+"TSV/Infos_CV.tsv", "header, tsv");
    
    int compte_lignes = -1;
    for (TableRow row : Infos_CV.rows()) {
        compte_lignes++;
        int     _ID_CV     = row.getInt(   "ID_CV");
        String  _fabricant = row.getString("fabricant");
        String  _famille   = row.getString("famille");
        String  _modele    = row.getString("modele");
        int     _v_reelle  = row.getInt(   "v_reelle");
        int     _frein     = row.getInt(   "frein");
        int     _elan      = row.getInt(   "elan");
        int     _p[]       = new int[5];
        for (int i = 0; i < 5; i++) {
            _p[i]          = row.getInt(   "P"+str(i));
        }
        int     _CV[]      = new int[201];
        for (int i = 1; i < 201; i++) {
            _CV[i]         = row.getInt(   "CV"+str(i));
        }
        
        Infos_CV inf0   = new Infos_CV();
        inf0.ID_CV      = _ID_CV;
        inf0.fabricant  = _fabricant;
        inf0.famille    = _famille;
        inf0.modele     = _modele;
        inf0.v_reelle   = _v_reelle;
        inf0.frein      = _frein/10000;
        inf0.elan       = _elan/10000;
        for (int i = 0; i < 5; i++) {
            inf0.p[i] = _p[i];
        }        
        for (int i = 1; i < 201; i++) {
            inf0.CV[i] = _CV[i];
        }
        toutes_infos_CV.add(inf0);
    }
}
//------------------------------ sauve_table_Vehicules() ---------------------------------------------------------
void sauve_table_Infos_CV() {
    Infos_CV.clearRows();    
    TableRow newRow;    
    int compte_infos_CV = -1;
    for (Infos_CV inf0 : toutes_infos_CV) {
        newRow = Infos_CV.addRow();
        compte_infos_CV++;
        Infos_CV.setInt(   compte_infos_CV,  "ID_CV",         inf0.ID_CV);
        Infos_CV.setString(compte_infos_CV,  "fabricant",  inf0.fabricant);
        Infos_CV.setString(compte_infos_CV,  "famille",    inf0.famille);
        Infos_CV.setString(compte_infos_CV,  "modele",     inf0.modele);
        Infos_CV.setInt(   compte_infos_CV,  "v_reelle",   inf0.v_reelle);
        Infos_CV.setInt(   compte_infos_CV,  "frein",      int(inf0.frein*10000));
        Infos_CV.setInt(   compte_infos_CV,  "elan",       int(inf0.elan*10000));        
        for (int i = 0; i < 5; i++) {
            Infos_CV.setInt(compte_infos_CV, "P"+str(i),  inf0.p[i]);
        }
        for (int i = 1; i < 201; i++) {
            Infos_CV.setInt(compte_infos_CV, "CV"+str(i), inf0.CV[i]);
        }
    }        
    saveTable(Infos_CV, Repertoire_Communs+"TSV/Infos_CV.tsv");
}
//********************************************************************** Proprietaires *********************************************************************************
//----------------------------- creation_table_Proprietaires() ---------------------------------
void creation_table_Proprietaires() {
    Proprietaires = new Table();    
    Proprietaires.addColumn("CV106");
    Proprietaires.addColumn("prop");
    for (int i = 1; i < 29; i++) {
        Proprietaires.addColumn("F"+str(i));
    }
}
//----------------------------- charge_table_Proprietaires() ------------------------------------
void charge_table_Proprietaires() {  
    Proprietaires = loadTable(Repertoire_Communs+"TSV/Proprietaires.tsv", "header, tsv");
    int compte_lignes = -1;
    tous_proprietaires.clear();
    for (TableRow row : Proprietaires.rows()) {
        compte_lignes++;
        int     _CV106  = row.getInt(   "CV106");
        String  _prop   = row.getString("prop");
        String  _F[]    = new String[29];                                                                                            //  nota : on démarre à 1
        for (int i = 1; i < 29; i++) {
            _F[i]       = row.getString("F"+str(i));
        }
        
        Proprietaire prop1 = new Proprietaire();
        prop1.CV106        = _CV106;
        prop1.prop         = _prop;
        for (int i = 1; i < 29; i++) {
            prop1.F[i] = _F[i];
        }        
        //---------------------- liste des proprietaires ----------------------
        boolean trouve = false;
        for (Proprietaire prop0 : tous_proprietaires) {
            if (prop0.prop.equals(prop1)) {
                trouve = true;
                break;
            }
        }
        if (!trouve) {
            tous_proprietaires.add(prop1);
        }
    }
}
//------------------------------ sauve_table_Proprietaires() ---------------------------------------------------------
void sauve_table_Proprietaires() {
    Proprietaires.clearRows();    
    TableRow newRow;    
    int compte_proprietaires = -1;
    for (Proprietaire prop0 : tous_proprietaires) {
        newRow = Proprietaires.addRow();
        compte_proprietaires++;
        Proprietaires.setInt(       compte_proprietaires, "CV106",    prop0.CV106);
        Proprietaires.setString(    compte_proprietaires, "prop",     prop0.prop);
        for (int i = 1; i < 29; i++) {
            Proprietaires.setString(compte_proprietaires, "F"+str(i), prop0.F[i]);
        }
    }        
    saveTable(Proprietaires, Repertoire_Communs+"TSV/Proprietaires.tsv");
}
//********************************************************* Base décodeurs *****************************************************************************************
//----------------------------- creation_table_Base_decodeurs() ---------------------------------
void creation_table_Base_decodeurs() {
    Base_decodeurs = new Table();    
    Base_decodeurs.addColumn("NMRA");
    Base_decodeurs.addColumn("Fabricant");
    Base_decodeurs.addColumn("Famille");
    Base_decodeurs.addColumn("Modele");
    Base_decodeurs.addColumn("Courant_moteur_max");
    Base_decodeurs.addColumn("Courant_pic_moteur");
    Base_decodeurs.addColumn("Duree_pic_moteur");    
    Base_decodeurs.addColumn("Courant_total_max");
    Base_decodeurs.addColumn("Courant_pic_total");
    Base_decodeurs.addColumn("Connecteur");
    Base_decodeurs.addColumn("Longueur");
    Base_decodeurs.addColumn("Largeur");
    Base_decodeurs.addColumn("Hauteur");
}
//----------------------------- charge_table_Base_decodeurs() ------------------------------------
void charge_table_Base_decodeurs() {  
    Base_decodeurs = loadTable(Repertoire_Communs+"TSV/Base_decodeurs.tsv", "header, tsv");
    int compte_lignes = -1;
    tous_decodeurs_base.clear();
    for (TableRow row : Base_decodeurs.rows()) {
        compte_lignes++;
        int     _NMRA       = row.getInt(   "NMRA");
        String  _fabricant  = row.getString("Fabricant");
        String  _famille    = row.getString("Famille");
        String  _modele     = row.getString("Modele");
        int     _c_m_max    = row.getInt(   "Courant_moteur_max");
        int     _c_p_m      = row.getInt(   "Courant_pic_moteur");
        int     _d_p_m      = row.getInt(   "Duree_pic_moteur");
        int     _c_t_max    = row.getInt(   "Courant_total_max");
        int     _c_p_t      = row.getInt(   "Courant_pic_total");
        String  _connecteur = row.getString("Connecteur");
        int     _longueur   = row.getInt(   "Longueur");
        int     _largeur    = row.getInt(   "Largeur");
        int     _hauteur    = row.getInt(   "Hauteur");
        
        Base_decodeurs base1     = new Base_decodeurs();
        base1.NMRA               = _NMRA;
        base1.fabricant          = _fabricant;
        base1.famille            = _famille;
        base1.modele             = _modele;
        base1.courant_moteur_max = _c_m_max;
        base1.courant_pic_moteur = _c_p_m;
        base1.duree_pic_moteur   = _d_p_m;
        base1.courant_total_max  = _c_t_max;
        base1.courant_pic_total  = _c_p_t;
        base1.connecteur         = _connecteur;
        base1.longueur           = _longueur;
        base1.largeur            = _largeur;
        base1.hauteur            = _hauteur;
        base1.reference          = _fabricant+"/"+_famille+"//"+_modele;
        //---------------------- liste des décodeurs base ----------------------
        tous_decodeurs_base.add(base1);
    }
}
//------------------------------ sauve_table_Base_decodeurs() ---------------------------------------------------------
void sauve_table_Base_decodeurs() {
    Base_decodeurs.clearRows();    
    TableRow newRow;    
    int compte_lignes = -1;
    for (Base_decodeurs base0 : tous_decodeurs_base) {
        newRow = Base_decodeurs.addRow();
        compte_lignes++;
        Base_decodeurs.setInt(   compte_lignes, "NMRA",               base0.NMRA);
        Base_decodeurs.setString(compte_lignes, "Fabricant",          base0.fabricant);
        Base_decodeurs.setString(compte_lignes, "Famille",            base0.famille);
        Base_decodeurs.setString(compte_lignes, "Modele",             base0.modele);
        Base_decodeurs.setInt(   compte_lignes, "Courant_moteur_max", base0.courant_moteur_max);
        Base_decodeurs.setInt(   compte_lignes, "Courant_pic_moteur", base0.courant_pic_moteur);
        Base_decodeurs.setInt(   compte_lignes, "Duree_pic_moteur",   base0.duree_pic_moteur);
        Base_decodeurs.setInt(   compte_lignes, "Courant_total_max",  base0.courant_total_max);
        Base_decodeurs.setInt(   compte_lignes, "Courant_pic_total",  base0.courant_pic_total);        
        Base_decodeurs.setString(compte_lignes, "Connecteur",         base0.connecteur);
        Base_decodeurs.setInt(   compte_lignes, "Longueur",           base0.longueur);
        Base_decodeurs.setInt(   compte_lignes, "Largeur",            base0.largeur);
        Base_decodeurs.setInt(   compte_lignes, "Hauteur",            base0.hauteur);
    }        
    saveTable(Base_decodeurs, Repertoire_Communs+"TSV/Base_decodeurs.tsv");
}
//********************************************************************** Compositions **************************************************************************
//----------------------------- creation_table_Compositions() ---------------------------------
void creation_table_Compositions() {
    Compositions = new Table();    
    Compositions.addColumn(    "nom");
    for (int i = 0; i < 20; i++) {
        Compositions.addColumn("veh"+str(i));
    }
}
//----------------------------- charge_table_Compositions() ------------------------------------
void charge_table_Compositions() {  
    Compositions = loadTable(Repertoire_Communs+"TSV/Compositions.tsv", "header, tsv");
    int compte_lignes = -1;
    toutes_compositions.clear();
    for (TableRow row : Compositions.rows()) {
        compte_lignes++;
        String  _nom    = row.getString("nom");
        int     _veh[]  = new int[20];
        for (int i = 0; i < 20; i++) {
            _veh[i]     = row.getInt(   "veh"+str(i));
        }
        
        Composition compo0 = new Composition();
        compo0.nom         = _nom;
        for (int i = 0; i < 20; i++) {
            for (Vehicule veh0 : tous_vehicules) {
                if (veh0.ID == _veh[i] && _veh[i] != -1) {
                    compo0.veh[i] = veh0;
                    break;
                }
            }
        }        
        //---------------------- liste des compositions ----------------------
        boolean trouve = false;
        for (Composition compo1 : toutes_compositions) {
            if (compo0.nom.equals(compo1)) {
                trouve = true;
                break;
            }
        }
        if (!trouve) {
            toutes_compositions.add(compo0);
        }
    }
    tables_construites = true;
}
//------------------------------ sauve_table_Compositions() ---------------------------------------------------------
void sauve_table_Compositions() {
    Compositions.clearRows();    
    TableRow newRow;    
    int compte_compositions = -1;
    for (Composition compo0 : toutes_compositions) {
        newRow = Compositions.addRow();
        compte_compositions++;
        Compositions.setString( compte_compositions, "nom",        compo0.nom);
        for (int i = 0; i < 20; i++) {
            if (compo0.veh[i] != null) {
                Compositions.setInt(compte_compositions, "veh"+str(i), compo0.veh[i].ID);
            } else {
                Compositions.setInt(compte_compositions, "veh"+str(i), -1);                
            }
        }
    }        
    saveTable(Compositions, Repertoire_Communs+"TSV/Compositions.tsv");
}
//*************************************************************************************************************************************************************
//*************************************************************************************************************************************************************
//************************************ class Vehicule *********************************************************************************************************
class Vehicule {
    //------------------------------------- description -----------------
    int         ID             = -1;
    int         ID_CV          = -1;
    String      nom;
    String      image_t;
    PImage      image_cote;
    String      marque;
    String      ref;
    int         htamp          = 0;                                                                                                                  //  longueur hors tampons mesurée sur le modèle
    color       couleur        = 0;        //  couleur du fond du véhicule
    String      echelle;
    boolean     moteur         = false;
    String      date;
    int         CV106          = 0;
    int         sauve_veh_I[]  = new int[3];        //  htamp, moteur, CV106
    String      sauve_veh_S[]  = new String[7];     //  nom, image_t, marque, ref, couleur, echelle, date
    boolean     filtre         = true;              //  par défaut, toutes les lignes sont affichées
    int         rang           = -1;

    Vehicule() {}  //  constructeur
}
//************************************ class Vehicule *********************************************************************************************************
class Infos_CV {
    //------------------------------------- description -----------------
    int         ID_CV          = 0;
    String      fabricant      = "n.c.";
    String      famille        = "n.c.";
    String      modele         = "n.c.";
    int         v_reelle       = 0;
    float       frein          = 1F;
    float       elan           = 1F;
    int         p[]            = new int[5];
    int         CV[]           = new int[201];
    int         sauve_CV_I[]   = new int[208];      //  v_reelle, frein, elan, 5p, 200 CV
    String      sauve_CV_S[]   = new String[3];     //  fabricant, famille, modele

    Infos_CV() {}  //  constructeur
}
//*********************************************************************************************************************
//************************************ class Proprietaire *********************************************************************************************************
class Proprietaire {
    //------------------------------------- description -----------------
    int         CV106;
    String      prop;
    String      F[]            = new String[29];

    Proprietaire() {}  //  constructeur
}
//*********************************************************************************************************************
//************************************ class Base_decodeurs *********************************************************************************************************
class Base_decodeurs {
    //------------------------------------- description -----------------
    int     NMRA               = 0;
    String  fabricant;
    String  famille;
    String  modele;
    int     courant_moteur_max = 0;
    int     courant_pic_moteur = 0;
    int     duree_pic_moteur   = 0;
    int     courant_total_max  = 0;
    int     courant_pic_total  = 0;
    String  connecteur;
    int     longueur           = 0;
    int     largeur            = 0;
    int     hauteur            = 0;
    String  reference;

    Base_decodeurs() {}  //  constructeur
}
//*********************************************************************************************************************
//************************************ class Composition *********************************************************************************************************
class Composition {
    //------------------------------------- description -----------------
    String   nom;
    Vehicule veh[] = new Vehicule[20];    
  
    Composition() {}
}
